// MainFrm.cpp : implementation of the CMainFrame class
// As part of the Undo_Redo_Demo application
// By Tom Morris of trilobiteWorks. December 2002
// Use freely...

#include "stdafx.h"
#include "Undo_Redo_Demo.h"
#include "Undo_Redo_DemoDoc.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
//	OnCreate
//	
/////////////////////////////////////////////////////////////////////////////
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
//	PreCreateWindow
//	
/////////////////////////////////////////////////////////////////////////////
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG

/////////////////////////////////////////////////////////////////////////////
//	AssertValid
//	
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


/////////////////////////////////////////////////////////////////////////////
//	OnEditUndo
//	
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnEditUndo()
{
	CUndo_Redo_DemoDoc	*pDoc = NULL;
	pDoc = (CUndo_Redo_DemoDoc*)GetActiveDocument();
	if (pDoc)
	{
		pDoc->DocVarsUndo();
	}
}


/////////////////////////////////////////////////////////////////////////////
//	OnUpdateEditUndo
//	
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateEditUndo(CCmdUI *pCmdUI)
{
	CUndo_Redo_DemoDoc	*pDoc = NULL;
	pDoc = (CUndo_Redo_DemoDoc*)GetActiveDocument();
	if (pDoc)
	{
		pCmdUI->Enable(pDoc->WeHaveUndosLeft());
	}
}


/////////////////////////////////////////////////////////////////////////////
//	OnEditRedo
//	
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnEditRedo()
{
	CUndo_Redo_DemoDoc	*pDoc = NULL;
	pDoc = (CUndo_Redo_DemoDoc*)GetActiveDocument();
	if (pDoc)
	{
		pDoc->DocVarsRedo();
	}
}


/////////////////////////////////////////////////////////////////////////////
//	OnUpdateEditRedo
//	
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateEditRedo(CCmdUI *pCmdUI)
{
	CUndo_Redo_DemoDoc	*pDoc = NULL;
	pDoc = (CUndo_Redo_DemoDoc*)GetActiveDocument();
	if (pDoc)
	{
		pCmdUI->Enable(pDoc->WeHaveRedosLeft());
	}
}
